using System;
using BepInEx.Configuration;
using HarmonyLib;

namespace TerraTech {
    [HarmonyPatch]
    public class ModuleEnergyStoreManager {
        private static readonly MultipliedObjectManager<ModuleEnergyStore> manager =
            new MultipliedObjectManager<ModuleEnergyStore>(ConfigureModuleEnergyStore);

        public static ConfigEntry<bool> playerOnly;
        public static ConfigEntry<float> capacityMultiplier;

        public static void Setup(ConfigFile config) {
            float min = 0.01f;
            float max = 32f;

            playerOnly = config.Bind("Energy", "Player Only", false, new ConfigDescription("Player Only"));
            playerOnly.SettingChanged += (sender, args) => DoPatch();

            capacityMultiplier =
                config.Bind("Energy", "Capacity Multiplier", 1f,
                            new ConfigDescription("Capacity Multiplier", new AcceptableValueRange<float>(min, max)));
            capacityMultiplier.SettingChanged += (sender, args) => DoPatch();
        }

        private static void ConfigureModuleEnergyStore(MultipliedObject<ModuleEnergyStore> obj) {
            obj.AddField(new FieldConfiguration<float, float>("m_Capacity", capacityMultiplier, ShouldApply));
        }

        private static readonly Func<object, bool> ShouldApply = obj => {
            if (!playerOnly.Value)
                return true;
            return CykUtil.IsPlayerTank(obj as Module);
        };

        [HarmonyPrefix]
        [HarmonyPatch(typeof(ModuleEnergyStore), "OnAttached")]
        static void PostfixCreate(ModuleEnergyStore __instance) {
            manager.OnObjectAttached(__instance);
        }

        [HarmonyPrefix]
        [HarmonyPatch(typeof(ModuleEnergyStore), "OnDetaching")]
        static void PostfixDestroy(ModuleEnergyStore __instance) {
            manager.OnObjectDetached(__instance);
        }

        public static void DoPatch() {
            manager.ApplyAll();
        }
    }
}
